use super::Solution;

use std::collections::HashMap;

pub struct LongestSubstring {}

impl Solution for LongestSubstring {
    fn solution(
        &self,
        input: &mut Vec<String>,
    ) -> Result<Box<dyn std::fmt::Display + Sync>, Box<dyn std::error::Error>> {
        let mut hm = HashMap::new();
        let mut largest = 0;
        let mut lo = -1;

        for s in input {
            for (hi, ch) in s.chars().enumerate() {
                if let Some(i) = hm.insert(ch, hi as i32) {
                    lo = lo.max(i);
                }
                largest = largest.max(hi as i32 - lo);
            }
        }

        Ok(Box::new(largest))
    }

    fn get_id(&self) -> u32 {
        3
    }
}

impl LongestSubstring {}

/// Test from puzzle input
#[cfg(test)]
mod test {
    use super::*;
    use crate::*;

    #[test]
    fn test1() {
        let solution = longest_substring::LongestSubstring {};

        //Complete the Challenge
        let answer = solution
            .solution(
                utils::get_input(solution.get_id(), utils::InputType::Test1)
                    .unwrap()
                    .as_mut(),
            )
            .unwrap()
            .to_string();

        assert_eq!(answer, "3");
    }

    #[test]
    fn test2() {
        let solution = longest_substring::LongestSubstring {};

        //Complete the Challenge
        let answer = solution
            .solution(
                utils::get_input(solution.get_id(), utils::InputType::Test2)
                    .unwrap()
                    .as_mut(),
            )
            .unwrap()
            .to_string();

        assert_eq!(answer, "1");
    }

    #[test]
    fn test3() {
        let solution = longest_substring::LongestSubstring {};

        //Complete the Challenge
        let answer = solution
            .solution(
                utils::get_input(solution.get_id(), utils::InputType::Test3)
                    .unwrap()
                    .as_mut(),
            )
            .unwrap()
            .to_string();

        assert_eq!(answer, "3");
    }
}
