use super::Solution;

pub struct PalidromicNumber {}

impl Solution for PalidromicNumber {
    fn solution(
        &self,
        input: &mut Vec<String>,
    ) -> Result<Box<dyn std::fmt::Display + Sync>, Box<dyn std::error::Error>> {
        let num: i32 = input.get(0).unwrap().parse::<i32>()?;

        let num_str: String = format!("{}", num);
        let rev: String = num_str.chars().rev().collect::<String>();
        Ok(Box::new(num_str == rev))
    }

    fn get_id(&self) -> u32 {
        9
    }
}

impl PalidromicNumber {}

/// Test from puzzle input
#[cfg(test)]
mod test {
    use super::*;
    use crate::*;

    #[test]
    fn test1() {
        let solution = palidromic_number::PalidromicNumber {};

        //Complete the Challenge
        let answer = solution
            .solution(
                utils::get_input(solution.get_id(), utils::InputType::Test1)
                    .unwrap()
                    .as_mut(),
            )
            .unwrap()
            .to_string();

        assert_eq!(answer, "true");
    }

    #[test]
    fn test2() {
        let solution = palidromic_number::PalidromicNumber {};

        //Complete the Challenge
        let answer = solution
            .solution(
                utils::get_input(solution.get_id(), utils::InputType::Test2)
                    .unwrap()
                    .as_mut(),
            )
            .unwrap()
            .to_string();

        assert_eq!(answer, "false");
    }

    #[test]
    fn test3() {
        let solution = palidromic_number::PalidromicNumber {};

        //Complete the Challenge
        let answer = solution
            .solution(
                utils::get_input(solution.get_id(), utils::InputType::Test3)
                    .unwrap()
                    .as_mut(),
            )
            .unwrap()
            .to_string();

        assert_eq!(answer, "false");
    }
}
