// Definition for singly-linked list.
#[derive(PartialEq, Eq, Clone, Debug)]
pub struct ListNode {
    pub val: i32,
    pub next: Option<Box<ListNode>>
}

impl ListNode {
    #[inline]
    pub fn new(val: i32) -> Self {
        ListNode {
            next: None,
            val
        }
    }

    pub fn from_vec(vec: Vec<i32>) -> Option<Box<Self>> {
        let mut current = None;
        for &v in vec.iter().rev() {
            let mut new_node = Box::new(ListNode::new(v));
            new_node.next = current;
            current = Some(new_node);
        }
        current
    }

    pub fn to_vec(node: Option<Box<Self>>) -> Vec<i32> {
        let mut vec = Vec::new();
        let mut current = node;
        while let Some(n) = current {
            vec.push(n.val);
            current = n.next;
        }
        vec
    }

    pub fn parse_list(s: &str) -> Vec<i32> {
        s.trim_matches(|c| c == '[' || c == ']')
        .split(',')
        .filter_map(|s| s.trim().parse().ok())
        .collect()
    }
}
